#ifndef _SppApp_h_
#define _SppApp_h_

/*******************************************************************************
*
* Project             Bluetooth Application
* File				  SppApp.h
* Description         Spp Application definitions
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2014
*
*******************************************************************************/

#   include "Spp.Api.h"
#   include "GattApp.h"
#   include <stdlib.h>
#   include <string.h>
#   include <stdio.h>
#   include <assert.h>

#if defined (CLX_WINDOWS)
#   include <direct.h>
#endif

#define SPP_SPEED_TEST
#define SPEED_MEASUREMENT 

#if defined(SPP_SPEED_TEST)
#	define TEST_BLOCK_SIZE			 333
#	define NUMBER_OF_TEST_BLOCKS	  130 // 384384
#	define HEADER_SIGNATURE			  0x41
#endif

#define FIXED_PIN_CODE

enum BtSecurityRequirement {BtHighSecurity = 0, BtMediumSecurity = 1, BtLowSecurity = 2, BtAutomaticSecurity = 3, BtNoSecurity = 4};

extern const s1* deviceClassList[];

extern u2 connectedDeviceId;


extern void connect(ClxHandle stack, ClxDeviceId deviceId, ClxHandle gatt, boolean server);
extern void discoverDevices(ClxStack stack, boolean liacMode);
extern void discoverServices(ClxStack stack, ClxDeviceId deviceId);
extern boolean stackMessageHandler(ClxStack stack, ClxHandle serviceHandle, u4 messageID, const void* params, ClxError errorCode);
extern ClxDeviceId selectPairedDevice(ClxStack stack, s1* selectedDeviceName);
extern void selectService(ClxStack stack, ClxDeviceId deviceId, const s1* deviceName);

#ifdef __cplusplus
extern "C" {
#endif

extern  void clxInitBsp(void);

#ifdef __cplusplus
}
#endif

extern ClxHandle gattHandle;
extern ClxHandle createGattHandle(ClxStack stack, s1* name, u2 appearance, bool server);
extern void deleteGattHandle(void);
extern ClxSemaphore sendSemaphore;
extern ClxSemaphore terminationSemaphore;


#endif //_SppApp_h_
