/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                File.cpp
* Description         BSP Support for File contents
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2014
*
*******************************************************************************/

// _____________________________________________________________________________
//
#undef  CLX_MODULE_ID
#define CLX_MODULE_ID  1028
// _____________________________________________________________________________
//
#include <stdlib.h>
#include "ClxBsp.h"
#include "ClxUserFile.h"

#ifdef __cplusplus
extern "C" {
#endif

 /*
These below tables are used as the fixed values if RAM_FILE_SUPPORTED, and CANNOT be changed
If FLASH_FILE_SUPPORTED, then these values are used as the default values, 
and they will be changed through out the execution
*/

// The following list specifies the system-defined debugger features:
// Bit 0   : Stack Tracing (function calls)
// Bit 1   : Warnings
// Bit 2   : Logging messages
// Bit 3   : Errors and Fatal Errors
// Bit 4   : Memory Analysis messages (allocations and deallocations)
// Bit 5   : Bluetooth Protocol Monitor messages
// Bit 6   : RFID Protocol Monitor messages
// Bit 7   : GPRS Protocol Monitor messages
// Bit 8   : Inter module Messaging
// Bit 9   : Virtual Console (Both input and output) messages
// Bit 10  : Co-operative Tasking Monitoring

static const s1 debugConfig[] =
"DEBUG_MEDIUM = UART\n"
"DEBUG_LOCAL_IP = 0.0.0.0\n"
"DEBUG_LOCAL_PORT = 4002\n"
"DEBUG_REMOTE_IP = 192.168.0.10\n"
"DEBUG_REMOTE_PORT = 14321\n"
"DEBUG_PORT_NAME = DEBUG_PORT\n"
"DEBUG_BAUD_RATE = 921600\n"
"DEBUG_DATA_BITS = 8\n"
"DEBUG_STOP_BITS = 0\n"
"TE_MEDIUM = UART\n"
"TE_PORT_NAME = DEBUG_PORT\n"
"TE_BAUD_RATE = 921600\n"
"TE_DATA_BITS = 8\n"
"TE_STOP_BITS = 0\n"
"DEBUG_TIMEOUT = 2000\n"
"DEBUG_BUFFER_SIZE = 3588\n"
//"DEBUG_FLAG = 11111111111\n\n";
"DEBUG_FLAG = 00000111000\n\n";


static const s1 bluetoothConfig[] =
"";



const VirtualFile fileList[] = { { StorageType_RAM, "SoftFrame.cfg",        {sizeof(debugConfig),               debugConfig             } },
                                 { StorageType_RAM, "ClarinoxBlue.cfg",     {sizeof(bluetoothConfig),           bluetoothConfig         } } ,
                                 { StorageType_RAM, NULL,                   {0, NULL                                                    } } };

extern const VirtualFile* clxVirtualFileSystemMap;
void initROMFileSystemMap()
{
  clxVirtualFileSystemMap = fileList;
}

#ifdef __cplusplus
}
#endif


