/******************************************************************************
*
* Project             Wlan Sample Application
* File                WiFiApp.h
* Description         Wlan application variable are declared here
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2014
*
*******************************************************************************/

#define MAX_JOINT_ST                10
#define REMOTE_TEST_UDP_PORT        6666
#define REMOTE_TEST_TCP_PORT        6666
#define REMOTE_ECHO_PORT            7
#define MAX_UI_INPUT_SIZE           64
#define NO_OF_SCAN_REPETITION       1
#define MAX_NO_OF_AP_IN_VICINITY    5


/**
The information of joint ST
*/
struct ClxStInfo
{
    u1    macAddr[CLX_MAC_ADDR_LEN];
};

enum InterfaceState
{
    Started,
    Stopped
};

namespace ClarinoxWLAN
{
    namespace Wl1271
    {
        extern ClxResult testSDIO(void *data);
    }
}

extern u1 jointStCount;
extern ClxHandle wlanHandle;
extern InterfaceState interfaceState;
extern const s1* clxWlanStackAPConfigName;
extern ClxStInfo jointStList[MAX_JOINT_ST];

extern "C" void clxInitBsp(void);
extern "C" void* getWl18xxPhysicalInterface(); 
extern "C" bool clxEnableWl18xxWlanHardware();
extern "C" bool clxDisableWl18xxWlanHardware();
extern "C" ClxWlanNetworkInterface* clxGetWlanTcpIpInterface();

extern void printCapabilties(u4 capabilities);
extern void showStationMenu(ClxStack stack);
extern void showAccessPointMenu(ClxStack stack);
extern boolean parseMacAddressString(const s1* str, u1* macAddrBuf);
extern boolean wlanIndicationHandler(ClxStack stack,
                                     ClxHandle serviceHandle,
                                     u4 messageID,
                                     const void* params,
                                     ClxError errorCode);

