#ifndef __ClxBsp_Errors__
#define __ClxBsp_Errors__

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                ClxBsp.Errors.h
* Description         Error codes to be reported by BSP-related functions
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#if !defined(CLX_SUCCESS)
#   define CLX_SUCCESS                                   0
#endif

#define CLX_SDIO_REQUEST_PENDING                        3400
#define CLX_SDIO_DRIVER_NOT_EXIST                       3401
#define CLX_SDIO_WRONG_STATE                            3402
#define CLX_SDIO_INIT_FAILED                            3403
#define CLX_SDIO_FAILED_TO_OPEN_DRIVER                  3404
#define CLX_SDIO_NO_CARD_INSERTED                       3405
#define CLX_SDIO_DEVICE_DRIVER_SHUT_DOWN                3406
#define CLX_SDIO_IO_FUNCTION_NOT_EXIST                  3407
#define CLX_SDIO_REQUEST_NOT_PROCESSED                  3408
#define CLX_SDIO_REQUEST_TYPE_NOT_RECOGNISED            3409
#define CLX_SDIO_REQUEST_NOT_SUCCESSFUL                 3410

#define CLX_FILE_END_OF_FILE                            -1
#define CLX_FILE_NOT_EXIST                              3500
#define CLX_FILE_IS_OPEN                                3501
#define CLX_FILE_NOT_WRITABLE                           3502
#define CLX_FILE_NOT_READABLE                           3503
#define CLX_FILE_NOT_APPENDABLE                         3503
#define CLX_FILE_OPEN_FAILED                            3504
#define CLX_FILE_CREATE_FAILED                          3505
#define CLX_FILE_ACCESS_DENIED                          3506
#define CLX_FILE_INVALID_HANDLE                         3507
#define CLX_FILE_LINE_NOT_FOUND                         3508
#define CLX_FILE_UNSPECIFIED_ERROR                      3509
#define CLX_FILE_OPEN_FLAG_NOT_CONSISTENT               3510
#define CLX_FILE_LEN_OVER_4GB_NOT_SUPPORTED             3511
#define CLX_FILE_ERROR_WRITING                          3512
#define CLX_FILE_ERROR_READING                          3513

#endif // __ClxBsp_Errors__
