#ifndef __I2c_Bsp__
#define __I2c_Bsp__

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                I2C.Bsp.h
* Description         Declares a I2C interface implemented by BSP 
*                     call-back functions
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#define CLX_USER_I2C_BSP_INTERFACE_CONFIG_FILE_NAME        "SoftFrame.cfg"
#define CLX_USER_I2C_BSP_INTERFACE_CONFIG_NAMESPACE        "ClxI2CUserApi"

/*
User configuration parameters for UART BSP interface may be defined as CLX_USER_UART_API_CONFIG_FILE_NAME.
within the namespace as defined by CLX_USER_UART_API_CONFIG_NAMESPACE.
*/
#define CLX_USER_I2C_API_MAX_CONFIG_PARAMS        10

#ifdef __cplusplus
extern "C" {
#endif

typedef void* ClxI2C_connection;
/**
Callback function prototypes used by BSP to handle stack function calls. 
*/
typedef struct ClxI2CBspInterfaceStruct
{
    /**
    This Callback function called when writing to the system
    \param[ in ] buffer to write
    \param[ in ] number of bytes to write
    \param[ in ] register to write

    \return ClxResult. Function must return either of the following result codes. 
    - CLX_SUCCESS: if operation is successful.
   
    */
    
    ClxResult (*write) (    u1* buffer,
                            u4 num_bytes,
                            u1 register_num);
    
    ClxResult (*read) (     u1* buffer,
                            u4 num_bytes,                                
                            u1 register_num);
   

} ClxI2CBspInterface;

extern ClxI2CBspInterface* clxI2CBspInterface;

#ifdef __cplusplus
}
#endif

#endif // __i2c_Bsp__
