#ifndef __IPERF_BSP__
#define __IPERF_BSP__

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                Iperf.Bsp.h
* Description         Declares IPerf interface for BSP
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif
  
#define IPERF_SERVER_PORT 5001
#define IPERF_CLIENT_PORT 5001
#define INTERVAL 2000
 
namespace ClxIperf
{



  enum clxIperfStates
  {
    CLX_IPERF_ACCEPT = 0,
    CLX_IPERF_CLOSE = 1
  };
  
  
  struct clxIperfServerState
  {
    clxIperfStates server_state;
    u4 rxData;
    //tcp_pcb *pcb;
    //pbuf *p;
  };


}

typedef struct ClxTcpIperfDataBspInterfaceStruct
{
    ClxResult (*init) (struct ClxTcpIperfDataBspInterfaceStruct* this_);

    void (*destroy) (struct ClxTcpIperfDataBspInterfaceStruct* this_);

    u4 (*newRequest) (struct ClxTcpIperfDataBspInterfaceStruct* this_);
        

    void (*dataRequired) (struct ClxTcpIperfDataBspInterfaceStruct* this_);

    u4 (*dataReceived) (struct ClxTcpIperfDataBspInterfaceStruct* this_);

    void (*requestComplete) (struct ClxTcpIperfDataBspInterfaceStruct* this_);

} ClxTcpIperfDataBspInterface;

extern ClxResult clxTcpIperfServerInit(ClxTcpIperfDataBspInterface* iperfDataInterface, u2 interval, const struct ClxNetworkServiceAddress* localAddr);

#ifdef __cplusplus
}
#endif

#endif // __IPERF_BSP__

