/*******************************************************************************
*
* Project             ClarinoxBlue
* File                VendorSpecific.cpp
* Description         BSP Support for Bluetooth Chip
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

// _____________________________________________________________________________
//
#undef  CLX_MODULE_ID
#define CLX_MODULE_ID  1025
// _____________________________________________________________________________
//

#include <cstdio>
#include <cstdlib>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stddef.h>

#include "ClxBsp.h"
#include "ClarinoxBlue.h"

typedef s4 ClxResult;

#include "ClxMemoryPoolset.h"

#define CLX_BLUETOOTH_UART_MAX_BAUDRATE                                               921600

#ifdef __cplusplus
extern "C" {
#endif
#if defined (CLX_BLUETOOTH_FIRMWARE_PAN1326)
#   include "PAN1326\PAN1326_Firmware.h" 
#   include "TI_VendorSpecific.h"
#elif defined (CLX_BLUETOOTH_FIRMWARE_WG7311)  
#   include "WG7311\WG7311_Firmware.h"
#   include "TI_VendorSpecific.h"
#elif defined (CLX_BLUETOOTH_FIRMWARE_WL1835 )  
#   include "Wl1835\WL1835_Firmware.h"
#   include "TI_VendorSpecific.h"
#elif defined (CLX_BLUETOOTH_FIRMWARE_LSRTiwiR2)
#   include "LSRTiwiR2\LSRTiwiR2_Firmware.h"
#   include "TI_VendorSpecific.h"
#else
#   error "You need to define a wireless chip and implement vendor specific functions"
    /*
    You need to define your Wireless chip vendor specific functions here. If a firmware needed to be loaded to the chip then Bsp.cpp needs to be modified;

    setting a call-back function which is called during the initialization of ClarinoxBlue stack.
    the call-back function is used to reset the Bluetooth controller, and to download the firmware
    into the controller using vendor specific HCI commands. Must be called before clxInitClarinoxBlue():

    clxHciSendVendorSpecificCommands        = clxInitBluetoothController;    

    In the clxInitBluetoothController function, you can use the following functions to reset the wireless chip, set baud rate and download firmware;
    - clxBluetoothIntegrity_HardResetController
    - clxBluetoothUartSetBaudRate
    - clxSendVendorSpecificCommand

    */
#endif




#ifdef __cplusplus
}
#endif
