/*******************************************************************************************************************************
*
* Project             Bluetooth Application
* File                Camera.cpp
* Description         This file defines Camera thread for the applications using camera.
*
* This file contains proprietary information of 
* Clarinox Technologies Proprietary Limited. 
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2014
*
*******************************************************************************************************************************/

#if defined (CLX_KOALA_CAMERA)

#include "ClxCommon.h"

#ifdef __cplusplus
 extern "C" {
#endif 
   
#include "camera.h"

extern void homeScreen( void );   
   
void initializeCamera (void)
{  
    Clock_Setup();
    Camera_Setup(); 
    OV9655_BrightnessConfig(0x20);  
}   
   
#ifdef __cplusplus
}
#endif


ClxSemaphore cameraSemaphore;
bool cameraRunning     = TRUE;
static bool cameraInitialized = FALSE;
extern u2 *buffer;

ClxResult CLX_CALLBACK cameraThread( void* notUsed )
{
    clxSleep(300);
    if(!cameraInitialized)
    {        
        cameraSemaphore = clxCreateSemaphore(0);
        cameraInitialized = TRUE;
    }
    while (cameraRunning)
    {   
        u2 i     = 0;
        u2 j     = 0;
        u2 *addr = buffer;
        clxSleep(100);
        for (i = 0; i < (H*2); i+=2)
        {
            for (j = 0; j< (W*2) ; j+=2)
            {       
                LCD_SetCursor(j,i);
                LCD_WriteRAM_Prepare();
                LCD_WriteRAM((uint16_t)*addr);

                LCD_SetCursor(j+1,i);
                LCD_WriteRAM_Prepare();
                LCD_WriteRAM(*addr);  

                LCD_SetCursor(j,i+1);
                LCD_WriteRAM_Prepare();
                LCD_WriteRAM(*addr);

                LCD_SetCursor(j+1,i+1);
                LCD_WriteRAM_Prepare();
                LCD_WriteRAM(*addr);    
                           
                addr++;
            }
        }
    }
    LCD_DeInit();
    STM324xG_LCD_Init();
    homeScreen();
    return CLX_SUCCESS;
}  

#endif //defined (CLX_KOALA_CAMERA)
