/*******************************************************************************************************************************
*
* Project             Bluetooth Application
* File                Camera.cpp
* Description         This file defines Camera thread for the applications using camera.
*
* This file contains proprietary information of 
* Clarinox Technologies Proprietary Limited. 
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2014
*
*******************************************************************************************************************************/

#include "ClxCommon.h"

#ifdef __cplusplus
 extern "C" {
#endif 

bool LcdFlip = TRUE;
	 
#if defined (CLX_KOALA_LCD)
   
#include "stm32f4xx_lcd.h"
#include "lcd_log.h"

extern void displayLogo(void);

void homeScreen( const u1* appName )
{    
    LCD_Clear(LCD_COLOR_BLACK);    
    LCD_LOG_SetHeader((uint8_t *)appName);
    LCD_LOG_SetFooter((uint8_t *)"Clarinox Koala V2.0 - uCos-III");
    LCD_LOG_ClearTextZone();
    LCD_SetTextColor(LCD_COLOR_WHITE);
    LCD_SetFont (&Font8x12);
}

void initializeLcd ( const u1* lcdAppName )
{ 
    STM324xG_LCD_Init();
    LCD_Clear(LCD_COLOR_BLACK);    
    displayLogo();
    homeScreen( lcdAppName );  
}

#endif //defined (CLX_KOALA_LCD)

#ifdef __cplusplus
}
#endif

