#ifndef __UartBsp_H__
#define __UartBsp_H__

/******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                UartBsp.h
* Description         This file includes Uart Bsp related declarations.
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2014
*
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif
#include "StmBsp.h"
  
#define USER_TIMEOUT                                                            ((uint32_t)0x64) /* Waiting 1s */
  
#if !defined(CLX_SUCCESS)
#define CLX_SUCCESS                                             				0
#endif

#if !defined(CLX_FAIL)
#define CLX_FAIL                                                				0xFFFFFFFF
#endif

#define TRUE			                                                        1
#define FALSE			                                                        0
  
#if defined (WMI)
// BLUETOOTH SETUP PARAMETERS
#   define BLUETOOTH_PORT 			USART1
#   define BLUETOOTH_PORT_NAME	 	"USART1"
#   define BLUETOOTH_PIN_TYPE		GPIO_AF_USART1		 
#   define BLUETOOTH_TX 			GPIO_Pin_9 
#   define BLUETOOTH_TX_PIN_SOURCE	GPIO_PinSource9	  
#   define BLUETOOTH_RX 			GPIO_Pin_10	  
#   define BLUETOOTH_RX_PIN_SOURCE	GPIO_PinSource10
#   define BLUETOOTH_GPIO_GROUP 	GPIOA
#   define BLUETOOTH_CTS 			GPIO_Pin_11
#   define BLUETOOTH_CTS_PIN_SOURCE	GPIO_PinSource11
#   define BLUETOOTH_RTS 			GPIO_Pin_12
#   define BLUETOOTH_RTS_PIN_SOURCE	GPIO_PinSource12
#   define BLUETOOTH_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOA
#   define BLUETOOTH_PORT_CLOCK_ALTERNATE_FUNCTION 	RCC_APB2Periph_USART1
#   define BLUETOOTH_PORT_DMA  		RCC_AHB1Periph_DMA2	
#   define BLUETOOTH_PORT_TX_DMA_CHANNEL		DMA_Channel_4
#   define BLUETOOTH_TX_DMA_STREAM	DMA2_Stream7
#   define BLUETOOTH_TX_DMA_IRQ_VECTOR DMA2_Stream7_IRQn
#   define BLUETOOTH_TX_DMA_TC_IRQ	DMA_IT_TCIF7
#   define BLUETOOTH_RX_IRQ_VECTOR	USART1_IRQn
// DEBUG PORT SETUP PARAMETERS
#   define DEBUG_PORT 				USART6
#   define DEBUG_PORT_NAME	 		"USART6"
#   define DEBUG_PIN_TYPE			GPIO_AF_USART6		 
#   define DEBUG_TX 				GPIO_Pin_6	  
#   define DEBUG_TX_PIN_SOURCE		GPIO_PinSource6	  
#   define DEBUG_RX 				GPIO_Pin_7
#   define DEBUG_RX_PIN_SOURCE		GPIO_PinSource7
#   define DEBUG_GPIO_GROUP 		GPIOC
#   define DEBUG_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOC
#   define DEBUG_PORT_CLOCK_ALTERNATE_FUNCTION 	RCC_APB2Periph_USART6
#   define DEBUG_PORT_DMA  			RCC_AHB1Periph_DMA2	
#   define DEBUG_TX_DMA_CHANNEL		DMA_Channel_5
#   define DEBUG_TX_DMA_STREAM		DMA2_Stream6
#   define DEBUG_TX_DMA_IRQ_VECTOR  DMA2_Stream6_IRQn
#   define DEBUG_TX_DMA_TC_IRQ		DMA_IT_TCIF6
#   define DEBUG_RX_IRQ_VECTOR		USART6_IRQn

// PAN WMI Module has shutdown
#if defined (PAN132X)
#   define BLUETOOTH_SHUTDOWN
#   define BLUETOOTH_SHUTDOWN_PIN							GPIO_Pin_7
#   define BLUETOOTH_SHUTDOWN_PORT							GPIOB
#   define BLUETOOTH_SHUTDOWN_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOB  
#   define FIRMWARE_FILE                                    "PAN1326_Firmware.h" 
#elif defined (WG7311)
#   define BLUETOOTH_SHUTDOWN
#   define BLUETOOTH_SHUTDOWN_PIN							GPIO_Pin_1
#   define BLUETOOTH_SHUTDOWN_PORT							GPIOB
#   define BLUETOOTH_SHUTDOWN_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOB  
#   define FIRMWARE_FILE                                    "WG7311_Firmware.h"
#endif

#else // KoalaEVM
// BLUETOOTH PORT SETUP PARAMETERS
#   define BLUETOOTH_PORT 			USART6
#   define BLUETOOTH_PORT_NAME	 	"USART6"
#   define BLUETOOTH_PIN_TYPE		GPIO_AF_USART6		 
#   define BLUETOOTH_TX 			GPIO_Pin_14	  
#   define BLUETOOTH_TX_PIN_SOURCE	GPIO_PinSource14	  
#   define BLUETOOTH_RX 			GPIO_Pin_9	  
#   define BLUETOOTH_RX_PIN_SOURCE	GPIO_PinSource9
#   define BLUETOOTH_GPIO_GROUP 	GPIOG	 
#   define BLUETOOTH_CTS 			GPIO_Pin_8	 
#   define BLUETOOTH_CTS_PIN_SOURCE	GPIO_PinSource8 
#   define BLUETOOTH_RTS 			GPIO_Pin_15	 	
#   define BLUETOOTH_RTS_PIN_SOURCE	GPIO_PinSource15  
#   define BLUETOOTH_PORT_DMA  		RCC_AHB1Periph_DMA2	
#   define BLUETOOTH_PORT_TX_DMA_CHANNEL		DMA_Channel_5
#   define BLUETOOTH_TX_DMA_STREAM	DMA2_Stream6
#   define BLUETOOTH_TX_DMA_IRQ_VECTOR DMA2_Stream6_IRQn
#   define BLUETOOTH_RX_IRQ_VECTOR	USART6_IRQn
#   define BLUETOOTH_TX_DMA_TC_IRQ	DMA_IT_TCIF6
#   define BLUETOOTH_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOG
#   define BLUETOOTH_PORT_CLOCK_ALTERNATE_FUNCTION 	RCC_APB2Periph_USART6
// DEBUG PORT SETUP PARAMETERS
#   define DEBUG_PORT 				USART1
#   define DEBUG_PORT_NAME	 		"USART1"
#   define DEBUG_PIN_TYPE			GPIO_AF_USART1		 
#   define DEBUG_TX 				GPIO_Pin_6 
#   define DEBUG_TX_PIN_SOURCE		GPIO_PinSource6
#   define DEBUG_RX 				GPIO_Pin_7
#   define DEBUG_RX_PIN_SOURCE		GPIO_PinSource7
#   define DEBUG_GPIO_GROUP 		GPIOB
#   define DEBUG_PORT_DMA  			RCC_AHB1Periph_DMA2	
#   define DEBUG_TX_DMA_CHANNEL		DMA_Channel_4
#   define DEBUG_TX_DMA_STREAM		DMA2_Stream7
#   define DEBUG_TX_DMA_IRQ_VECTOR	DMA2_Stream7_IRQn
#   define DEBUG_TX_DMA_TC_IRQ		DMA_IT_TCIF7
#   define DEBUG_RX_IRQ_VECTOR		USART1_IRQn
#   define DEBUG_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOB
#   define DEBUG_PORT_CLOCK_ALTERNATE_FUNCTION 	RCC_APB2Periph_USART1

// WiLink Modules require Enable
#   define BLUETOOTH_ENABLE
#   define BLUETOOTH_ENABLE_PIN								GPIO_Pin_6
#   define BLUETOOTH_ENABLE_PORT							GPIOE
#   define BLUETOOTH_ENABLE_PORT_CLOCK_SETUP_GPIO	 		RCC_AHB1Periph_GPIOE

#if defined (Wl18xx)
#   define FIRMWARE_FILE           "Wl18xx_Firmware.h"
#else
#   define FIRMWARE_FILE           "LSR_Tiwi_R2_Firmware.h"
#endif
  
#endif

#define UART_RX_BUFFER_SIZE                                                           2048


#define WAIT_FOR_DEBUG_PORT_TX_SEMAPHORE                                              clxAcquireSemaphore(BSP_SerTxWait_Debug);  
                                                                                        
#define RELEASE_DEBUG_PORT_TX_SEMAPHORE                                               clxReleaseSemaphore(BSP_SerTxWait_Debug);
                                                                                        
#define RELEASE_BLUETOOTH_PORT_TX_SEMAPHORE                                           clxReleaseSemaphore(BSP_SerTxWait_Bluetooth);                                                                                        
                                                                                       
#define WAIT_FOR_BLUETOOTH_PORT_TX_SEMAPHORE                                          clxAcquireSemaphore(BSP_SerTxWait_Bluetooth);
                                                                                        
#define WAIT_FOR_DEBUG_PORT_DATA_READ_SEMAPHORE	                                      clxAcquireSemaphore(BSP_SerRxWait_Debug);

#define RELEASE_DEBUG_PORT_DATA_READ_SEMAPHORE     	                                  clxReleaseSemaphore(BSP_SerRxWait_Debug);
                                                                                      
#define WAIT_FOR_BLUETOOTH_PORT_DATA_READ_SEMAPHORE	                                  clxAcquireSemaphore(BSP_SerRxWait_Bluetooth);

#define RELEASE_BLUETOOTH_PORT_DATA_READ_SEMAPHORE     	                              clxReleaseSemaphore(BSP_SerRxWait_Bluetooth);    
                                                                                      
                                                                                      
#ifdef __cplusplus
}
#endif

#endif // __Uart_Bsp_H__
