#ifndef _ClarinoxBlueErrorCodes_
#define _ClarinoxBlueErrorCodes_

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                ClarinoxBlueErrorCodes.h
* Description         Declares ClarinoxBlue errors
*
* This file contains proprietary information of 
* Clarinox Technologies Proprietary Limited. 
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/


#include "ClarinoxErrorCodes.h"


#define CLX_CLARINOX_BLUE_ERROR_CODE_BASE                           0x0030
#define CLX_CLARINOX_BLUE_ERROR_CODE_END                            0x0418  /* 1000 error codes are reserved for ClarinoxBlue */

#define CLX_ERROR_CLARINOX_BLUE_FAILED                              (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 0)
#define CLX_ERROR_CLARINOX_BLUE_TERMINATED                          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 1)
#define CLX_ERROR_INVALID_DEVICE_ID                                 (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 2)
#define CLX_ERROR_DEVICE_ALREADY_PAIRED                             (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 3)
#define CLX_ERROR_INQUIRY_IN_PROGRESS                               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 4)
#define CLX_ERROR_INVALID_COMMAND_PARAMETER                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 5)
#define CLX_ERROR_INQUIRY_NOT_IN_PROGRESS                           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 6)
#define CLX_ERROR_GAP_PROCEDURE_IN_PROGRESS                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 7)
#define CLX_ERROR_GAP_CONNECTION_NOT_SUCCESSFUL                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 8)
#define CLX_ERROR_GAP_LOCAL_DEVICE_NOT_BONDABLE                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 9)
#define CLX_ERROR_GAP_REMOTE_DEVICE_NOT_BONDABLE                    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 10)
#define CLX_ERROR_SERVICE_DISCOVERY_FAILED                          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 11)
#define CLX_ERROR_SERVICE_DISCOVERY_IN_PROGRESS                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 12)
#define CLX_ERROR_NOT_SUPPORTED_BY_REMOTE_MACHINE                   (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 13)
#define CLX_ERROR_OBEX_OBJECT_TRANSFER_IN_PROGRESS                  (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 14)
#define CLX_ERROR_SPP_UNDISCOVERED_COM_PORT                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 15)

#define CLX_ERROR_AUDIO_CONNECTION_EXISTS                           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 16)
#define CLX_ERROR_AUDIO_CONNECTION_NOT_EXIST                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 17)
#define CLX_ERROR_AUDIO_CONNECTION_IN_PROGRESS                      (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 18)
#define CLX_ERROR_AUDIO_DISCONNECTION_IN_PROGRESS                   (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 19)
#define CLX_ERROR_AUDIO_CONNECTION_FAILED                           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 20)

#define CLX_ERROR_MCE_NO_BOUND_DEVICE                               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 21)
#define CLX_ERROR_MCE_BINDING_IN_PROGRESS                           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 22)
#define CLX_ERROR_MCE_UNBINDING_IN_PROGRESS                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 23)
#define CLX_ERROR_MCE_ALREADY_BOUND                                 (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 24)
#define CLX_ERROR_MCE_NO_SERVERS_AVAILABLE                          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 25)
#define CLX_ERROR_MCE_INVALID_SERVER_ID                             (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 26)

#define CLX_ERROR_OBEX_APP_PARAMS_TOO_BIG                           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 27)
#define CLX_ERROR_OBEX_BAD_REQUEST                                  (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 28)
#define CLX_ERROR_OBEX_NOT_FOUND                                    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 29)
#define CLX_ERROR_OBEX_FORBIDDEN                                    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 30)
#define CLX_ERROR_OBEX_INTERNAL_SERVER_ERROR                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 31)
#define CLX_ERROR_OBEX_UNAUTHERIZED                                 (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 32)
#define CLX_ERROR_OBEX_OPERATION_ABORTED                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 33)
#define CLX_ERROR_OBEX_NOT_ACCEPTABLE                               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 34)

#define CLX_ERROR_A2DP_SIGNALING_CONN_DROPPED                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 35)
#define CLX_ERROR_A2DP_STREAMING_CONN_DROPPED                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 36)
#define CLX_ERROR_A2DP_SIGNALING_TIMEOUT                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 37)
#define CLX_ERROR_A2DP_NO_MATCHING_ENDPOINT                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 38)
#define CLX_ERROR_A2DP_WRONG_STATE                                  (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 39)
#define CLX_ERROR_A2DP_ALREADY_CONNECTED                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 40)
#define CLX_ERROR_A2DP_CONNECTING                                   (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 41)
#define CLX_ERROR_A2DP_INVALID_STATE                                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 42)
#define CLX_ERROR_A2DP_ENDPOINT_IN_USE                              (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 43)
#define CLX_ERROR_A2DP_LOCAL_SERVICE_ACCEPTOR                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 44)
#define CLX_ERROR_A2DP_CONFIG_NOT_SUPPORTED_BY_REMOTE_MACHINE       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 45)
#define CLX_ERROR_A2DP_CONFIG_NOT_SUPPORTED_BY_LOCAL_CODEC          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 46)
#define CLX_ERROR_A2DP_PLAYING                                      (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 47)
#define CLX_ERROR_A2DP_PAUSED                                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 48)
#define CLX_ERROR_A2DP_ABORTED                                      (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 49)
#define CLX_ERROR_A2DP_INVALID_MEDIA_CODEC                          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 50)


#define CLX_ERROR_HFP_AG_CALL_SETUP_IN_PROGRESS                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 51)
#define CLX_ERROR_HFP_AG_CALL_IS_ACTIVE                             (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 52)
#define CLX_ERROR_HFP_AG_NO_CALL_IS_ACTIVE                          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 53)
#define CLX_ERROR_HFP_AG_NO_OUTGOING_CALL_SETUP                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 54)
#define CLX_ERROR_HFP_AG_NO_OUTGOING_CALL_REQUEST_PENDING           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 55)
#define CLX_ERROR_HFP_AG_NO_INCOMING_CALL_REQUEST_PENDING           (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 56)
#define CLX_ERROR_HFP_AG_INBAND_RING_NOT_SUPPORTED                  (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 57)
#define CLX_ERROR_HFP_AG_CALL_WITH_SAME_INDEX_EXISTS                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 58)
#define CLX_ERROR_HFP_AG_INVALID_CALL_INDEX                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 59)
#define CLX_ERROR_HFP_AG_CALL_CANNOT_BE_ACTIVATED                   (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 60)

#define CLX_ERROR_HFP_HF_WRONG_STATE                                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 61)
#define CLX_ERROR_HFP_HF_SUBSCRIBER_NUM_INFO_NOT_SUPPORTED_IN_AG    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 62)
#define CLX_ERROR_HFP_HF_VOICE_RECOGNITION_NOT_SUPPORTED_IN_AG      (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 63)
#define CLX_ERROR_HFP_HF_CALLING_LINE_ID_NOT_SUPPORTED_IN_AG        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 64)
#define CLX_ERROR_HFP_HF_FEATURE_NOT_SUPPORTED_IN_AG                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 65)
#define CLX_ERROR_HFP_HF_FEATURE_NOT_SUPPORTED_IN_HF                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 66)
#define CLX_ERROR_HFP_HF_REQUEST_DENIED_BY_AG                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 67)

#define CLX_ERROR_AVRCP_NOT_SUPPORTED_IN_TARGET                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 68)

#define CLX_ERROR_BLE_GATT_MAX_NUMBER_OF_SERVICES_EXCEEDED          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 69)
#define CLX_ERROR_BLE_ATT_INTERNAL_ERROR                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 70)
#define CLX_ERROR_BLE_ATT_INVALID_HANDLE                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 71)
#define CLX_ERROR_BLE_ATT_READ_NOT_PERMITTED                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 72)
#define CLX_ERROR_BLE_ATT_WRITE_NOT_PERMITTED                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 73)
#define CLX_ERROR_BLE_ATT_INVALID_PDU                               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 74)
#define CLX_ERROR_BLE_ATT_INSUFFICIENT_AUTHENTICATION               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 75)
#define CLX_ERROR_BLE_ATT_REQUEST_NOT_SUPPORTED                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 76)
#define CLX_ERROR_BLE_ATT_INVALID_OFFSET                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 77)
#define CLX_ERROR_BLE_ATT_INSUFFICIENT_AUTHORIZATION                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 78)
#define CLX_ERROR_BLE_ATT_PREPARE_QUEUE_FULL                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 79)
#define CLX_ERROR_BLE_ATT_ATTRIBUTE_NOT_FOUND                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 80)
#define CLX_ERROR_BLE_ATT_ATTRIBUTE_NOT_LONG                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 81)
#define CLX_ERROR_BLE_ATT_INSUFFICIENT_ENCRYPTION_KEY_SIZE          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 82)
#define CLX_ERROR_BLE_ATT_INVALID_ATTRIBUTE_VALUE_LENGTH            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 83)
#define CLX_ERROR_BLE_ATT_UNLIKELY_ERROR                            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 84)
#define CLX_ERROR_BLE_ATT_INSUFFICIENT_ENCRYPTION                   (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 85)
#define CLX_ERROR_BLE_ATT_UNSUPPORTED_GROUP_TYPE                    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 86)
#define CLX_ERROR_BLE_ATT_INSUFFICIENT_RESOURCES                    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 87)
#define CLX_ERROR_BLE_CODEC_NOT_IMPLEMENTED                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 88)
#define CLX_ERROR_BLE_WRONG_ENCODED_DATA_LENGTH                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 89)
#define CLX_ERROR_BLE_NOT_CHARACTERISTIC_VALUE_ATTRIBUTE            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 90)

#define CLX_ERROR_AVRCP_INSUFFICIENT_MINIMUM_BUFFER_MEMORY          (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 91)
#define CLX_ERROR_AVRCP_CORRUPTED_BROWSE_RESPONSE_PACKET            (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 92)

#define CLX_ERROR_NETWORK_SERVICE_INTERFACE_IN_WRONG_STATUS         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 93)

#define CLX_ERROR_IPSP_NOT_SUPPORTED_BY_LOCAL_ROLE                  (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 94)
#define CLX_ERROR_IPSP_INTERFACE_ALREADY_STARTED                    (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 95)
#define CLX_ERROR_IPSP_INTERFACE_NOT_STARTED                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 96)
#define CLX_ERROR_IPSP_NO_PHYSICAL_LINK_TO_PERIPHERAL               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 97)
#define CLX_ERROR_IPSP_CONNECTION_LIMIT_REACHED                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 98)
#define CLX_ERROR_IPSP_ANOTHER_PROCEDURE_IN_PROGRESS                (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 99)

#define CLX_ERROR_BLE_SMP_PASSKEY_ENTRY_FAILED                      (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 100)
#define CLX_ERROR_BLE_SMP_OOB_NOT_AVAILABLE                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 101)
#define CLX_ERROR_BLE_SMP_AUTHENTICATION_REQUIREMENTS               (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 102)
#define CLX_ERROR_BLE_SMP_CONFIRM_VALUE_FAILED                      (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 103)
#define CLX_ERROR_BLE_SMP_PAIRING_NOT_SUPPORTED                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 104)
#define CLX_ERROR_BLE_SMP_ENCRYPTION_KEY_SIZE                       (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 105)
#define CLX_ERROR_BLE_SMP_COMMAND_NOT_SUPPORTED                     (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 106)
#define CLX_ERROR_BLE_SMP_UNSPECIFIED_REASON                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 107)
#define CLX_ERROR_BLE_SMP_REPEATED_ATTEMPTS                         (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 108)
#define CLX_ERROR_BLE_SMP_INVALID_PARAMETERS                        (CLX_CLARINOX_BLUE_ERROR_CODE_BASE + 109)

#endif // _ClarinoxBlueErrorCodes_
