#ifndef _HSP_COMMON_API_H_
#define _HSP_COMMON_API_H_

/*******************************************************************************
*
* Project             ClarinoxBlue
* File                Hsp.Common.Api.h
* Description         Declares ClarinoxBlue Headset Profile Common API for both roles
*
* This file contains proprietary information of 
* Clarinox Technologies Proprietary Limited. 
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

/**
The parameter type of both #CLX_HSP_AG_SPEAKER_GAIN_REPORT_INDICATION indication
and #CLX_HSP_AG_MICROPHONE_GAIN_REPORT_INDICATION indication.
*/
struct ClxHspGainReport
{
    u1 level;    /*!< The current volume level of the headset speaker or microphone as reported by the remote headset device */
};

/**
The parameter type of the following indications:
#CLX_HSP_AG_CONNECTION_INDICATION
#CLX_HSP_HS_CONNECTION_INDICATION
#CLX_HSP_HS_DISCONNECTION_INDICATION
*/
struct ClxHspConnectionIndication
{
    ClxDeviceId deviceId;    /*!< The device ID of the remote device to which the HSP connection has been established or disconnected */
};

#ifdef __cplusplus
}
#endif


#endif // _HSP_COMMON_API_H_
