#ifndef _ClarinoxErrorCodes_
#define _ClarinoxErrorCodes_

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                ClarinoxErrorCodes.h
* Description         ClarinoxSoftFrame common error code definitions
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#if !defined(CLX_SUCCESS)
#define CLX_SUCCESS                                             0
#endif

#if !defined(CLX_FAIL)
#define CLX_FAIL                                                0xFFFFFFFF
#endif

#if !defined(CLX_ERROR)
#define CLX_ERROR                                               0xFFFFFFFF
#endif


#define CLX_ERROR_COMPLETION_PENDING                            0x0001      /* Not indicating an error. Indicates that an initiated procedure will continue asynchronously 
                                                                               in a context different from the one in which this error has been received */ 
#define CLX_ERROR_INTERNAL_ERROR                                0x0002
#define CLX_ERROR_INVALID_CALLBACK                              0x0003
#define CLX_ERROR_INVALID_HANDLE                                0x0004
#define CLX_ERROR_INVALID_COMMAND_ARGUMENT                      0x0005
#define CLX_ERROR_COMMAND_NOT_COMPLETE                          0x0006
#define CLX_ERROR_COMMAND_UNSUCCESSFUL                          0x0007
#define CLX_ERROR_COMMAND_CANCELLED                             0x0008
#define CLX_ERROR_TIMEOUT_OCCURRED                              0x0009
#define CLX_ERROR_ANOTHER_COMMAND_IN_PROGRESS                   0x000A
#define CLX_ERROR_CONNECTION_FAILED                             0x000B
#define CLX_ERROR_CONNECTION_EXISTS                             0x000C
#define CLX_ERROR_CONNECTION_NOT_EXIST                          0x000D
#define CLX_ERROR_CONNECTION_ESTABLISHMENT_IN_PROGRESS          0x000E
#define CLX_ERROR_CONNECTION_INITIATION_NOT_ALLOWED             0x000F
#define CLX_ERROR_DISCONNECTION_IN_PROGRESS                     0x0010
#define CLX_ERROR_INVALID_REQUEST                               0x0011
#define CLX_ERROR_HANDLE_COMMANDS_PENDING                       0x0012


#define CLX_ERROR_EPERM                                         0xA001
#define CLX_ERROR_ENOENT                                        0xA002
#define CLX_ERROR_ESRCH                                         0xA003
#define CLX_ERROR_EINTR                                         0xA004
#define CLX_ERROR_EIO                                           0xA005
#define CLX_ERROR_ENXIO                                         0xA006
#define CLX_ERROR_E2BIG                                         0xA007
#define CLX_ERROR_ENOEXEC                                       0xA008
#define CLX_ERROR_EBADF                                         0xA009
#define CLX_ERROR_ECHILD                                        0xA00A
#define CLX_ERROR_EAGAIN                                        0xA00B
#define CLX_ERROR_ENOMEM                                        0xA00C
#define CLX_ERROR_EACCES                                        0xA00D
#define CLX_ERROR_EFAULT                                        0xA00E
#define CLX_ERROR_EBUSY                                         0xA00F
#define CLX_ERROR_EEXIST                                        0xA010
#define CLX_ERROR_EXDEV                                         0xA011
#define CLX_ERROR_ENODEV                                        0xA012
#define CLX_ERROR_ENOTDIR                                       0xA013
#define CLX_ERROR_EISDIR                                        0xA014
#define CLX_ERROR_ENFILE                                        0xA015
#define CLX_ERROR_EMFILE                                        0xA016
#define CLX_ERROR_ENOTTY                                        0xA017
#define CLX_ERROR_EFBIG                                         0xA018
#define CLX_ERROR_ENOSPC                                        0xA019
#define CLX_ERROR_ESPIPE                                        0xA01A
#define CLX_ERROR_EROFS                                         0xA01B
#define CLX_ERROR_EMLINK                                        0xA01C
#define CLX_ERROR_EPIPE                                         0xA01D
#define CLX_ERROR_EDOM                                          0xA01E
#define CLX_ERROR_EDEADLK                                       0xA01F
#define CLX_ERROR_ENAMETOOLONG                                  0xA020
#define CLX_ERROR_ENOLCK                                        0xA021
#define CLX_ERROR_ENOSYS                                        0xA022
#define CLX_ERROR_ENOTEMPTY                                     0xA023


#endif // _ClarinoxErrorCodes_
