#ifndef _ClxConsole_
#define _ClxConsole_

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                ClxConsole.h
* Description         Declares ClxConsole related declarations
*
* This file contains proprietary information of 
* Clarinox Technologies Proprietary Limited. 
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


/*
Declaration for the userPrintfFunction; if this function pointer is assigned to a user "printf" function, then the debug prints will be redirected here. 
*/
extern void (*userPrintfFunction) ( char* formattedOutput );

/*
Called by the system when user input is required.
*/
extern int (*userGetInputFunction) ( char* buffer, unsigned int bufferSize );

/**
Read one character from standard input, without echoing it to the standard output
\return The character read.
*/
extern char clxGetChar();

/**
Read one character from standard input, and put it on standard output.
\return The character read.
*/
extern char clxGetCharEcho( void );
/**
Put one character back to the standard input.
\param[ in ] c The character to put back.
*/
extern void clxUnGetChar  ( char c );

/**
Print a string to the standard output. If the function userPrintfFunction() has been implemented by the application,
it will be called. Otherwise, the default "printf" function for the underlying platform will be called.
\param[ in ] string pointer to the null-terminated string to be printed.
*/
extern void clxPrintString ( s1* string );


#ifdef __cplusplus
}
#endif


#endif    // _ClxConsole_

