#ifndef _ClxDataConversion_
#define _ClxDataConversion_

/*******************************************************************************
*
* Project             ClarinoxSoftFrame
* File                ClxDataConversion.h
* Description         Clarinox Type conversion
*
* This file contains proprietary information of
* Clarinox Technologies Proprietary Limited.
* Copying or reproduction without prior written approval is prohibited.
*
* All rights reserved (C) Copyright Clarinox Technologies Pty Ltd 2001-2015
*
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif


/**
ClxUnicodeToChar - Simple Unicode to char function.
\param c Destination (char)
\param uc Source (Unicode)
\param size Length of destination buffer, at least half the size of source
\return buffers may not overlap and -1 on error.
*/
extern int ClxUnicodeToChar(s1 *c, const s1 *uc, int size);

/**
ClxCharToUnicode - Simple char to Unicode function.
\param uc Destination (Unicode)
\param c Source (char)
\param size Length of destination buffer, at least twice the size of source
\return buffers may not overlap and -1 on error.
 */
extern int ClxCharToUnicode(s1 *uc, const s1 *c, int size);

#ifdef __cplusplus
}
#endif


#endif    // _ClxDataConversion_
